Index: test/src/test/java/org/hippoecm/hst/test/JcrHippoRepository.java
===================================================================
--- test/src/test/java/org/hippoecm/hst/test/JcrHippoRepository.java	(revision 32948)
+++ test/src/test/java/org/hippoecm/hst/test/JcrHippoRepository.java	(working copy)
@@ -32,7 +32,8 @@
 public class JcrHippoRepository implements Repository {
     
     private static final Logger log = LoggerFactory.getLogger(JcrHippoRepository.class);
-    
+    private static final String[] EMPTY_STRING_ARRAY = {};
+
     protected String repositoryURI;
     protected HippoRepository hippoRepository;
     protected boolean vmRepositoryUsed;
@@ -81,7 +82,7 @@
     }
 
     public String[] getDescriptorKeys() {
-        String [] descriptorKeys = {};
+        String [] descriptorKeys = EMPTY_STRING_ARRAY;
         
         if (hippoRepository != null) {
             ClassLoader currentClassloader = switchToRepositoryClassloader();
Index: client-modules/page-composer/src/main/java/org/hippoecm/hst/pagecomposer/jaxrs/model/ExtResponseRepresentation.java
===================================================================
--- client-modules/page-composer/src/main/java/org/hippoecm/hst/pagecomposer/jaxrs/model/ExtResponseRepresentation.java	(revision 32948)
+++ client-modules/page-composer/src/main/java/org/hippoecm/hst/pagecomposer/jaxrs/model/ExtResponseRepresentation.java	(working copy)
@@ -22,12 +22,13 @@
  */
 
 public class ExtResponseRepresentation {
+    private static final String[] EMPTY_STRING_ARRAY = new String[0];
     private boolean success;
     private String message;
     private Object data;
 
     public ExtResponseRepresentation() {
-        this(new String[0]);
+        this(EMPTY_STRING_ARRAY);
     }
 
     public ExtResponseRepresentation(Object data) {
Index: client-modules/page-composer/src/main/java/org/hippoecm/hst/pagecomposer/jaxrs/services/AbstractConfigResource.java
===================================================================
--- client-modules/page-composer/src/main/java/org/hippoecm/hst/pagecomposer/jaxrs/services/AbstractConfigResource.java	(revision 32948)
+++ client-modules/page-composer/src/main/java/org/hippoecm/hst/pagecomposer/jaxrs/services/AbstractConfigResource.java	(working copy)
@@ -45,8 +45,9 @@
 public class AbstractConfigResource {
     
     private static Logger log = LoggerFactory.getLogger(AbstractConfigResource.class);
+    private static final String[] EMPTY_STRING_ARRAY = new String[0];
 
-    
+
     private ObjectConverter objectConverter;
     private MountDecorator mountDecorator;
     private List<Class<? extends HippoBean>> annotatedClasses;
@@ -109,7 +110,7 @@
     }
 
     protected Response ok(String msg) {
-        return ok(msg, new String[0]);
+        return ok(msg, EMPTY_STRING_ARRAY);
     }
 
     protected Response ok(String msg, Object data) {
@@ -120,7 +121,7 @@
     }
 
     protected Response error(String msg) {
-        return error(msg, new String[0]);
+        return error(msg, EMPTY_STRING_ARRAY);
     }
 
     protected Response error(String msg, Object data) {
Index: components/jaxrs/src/main/java/org/hippoecm/hst/jaxrs/services/content/BaseImageSetContentResource.java
===================================================================
--- components/jaxrs/src/main/java/org/hippoecm/hst/jaxrs/services/content/BaseImageSetContentResource.java	(revision 32948)
+++ components/jaxrs/src/main/java/org/hippoecm/hst/jaxrs/services/content/BaseImageSetContentResource.java	(working copy)
@@ -62,7 +62,8 @@
 public class BaseImageSetContentResource extends AbstractContentResource {
     
     private static Logger log = LoggerFactory.getLogger(BaseImageSetContentResource.class);
-    
+    private static final byte[] EMPTY_BYTE_ARRAY = new byte[0];
+
     private HstCache binariesCache;
     
     public HstCache getBinariesCache() {
@@ -147,7 +148,7 @@
             final String mimeType = childImageBean.getMimeType();
             
             if (!childImageBean.getNode().hasProperty("jcr:data")) {
-                return Response.ok(new byte[0], MediaType.valueOf(mimeType)).build();
+                return Response.ok(EMPTY_BYTE_ARRAY, MediaType.valueOf(mimeType)).build();
             }
             
             final Binary binary = childImageBean.getNode().getProperty("jcr:data").getBinary();
Index: components/core/src/main/java/org/hippoecm/hst/core/component/HstResponseImpl.java
===================================================================
--- components/core/src/main/java/org/hippoecm/hst/core/component/HstResponseImpl.java	(revision 32948)
+++ components/core/src/main/java/org/hippoecm/hst/core/component/HstResponseImpl.java	(working copy)
@@ -40,6 +40,7 @@
  */
 public class HstResponseImpl extends HttpServletResponseWrapper implements HstResponse
 {
+    private static final String[] EMPTY_STRING_ARRAY = new String[0];
     protected HttpServletRequest request;
     protected HttpServletResponse response;
     protected HstRequestContext requestContext;
@@ -358,7 +359,7 @@
     
     public void setRenderParameter(String key, String value) {
         if (value == null) {
-            setRenderParameter(key, new String[0]);
+            setRenderParameter(key, EMPTY_STRING_ARRAY);
         } else {
             setRenderParameter(key, new String [] { value });
         }
Index: components/core/src/main/java/org/hippoecm/hst/core/component/HstRequestImpl.java
===================================================================
--- components/core/src/main/java/org/hippoecm/hst/core/component/HstRequestImpl.java	(revision 32948)
+++ components/core/src/main/java/org/hippoecm/hst/core/component/HstRequestImpl.java	(working copy)
@@ -54,7 +54,8 @@
     public static final String CONTAINER_ROLE_PRINCIPAL_CLASSNAME_PROP_KEY = HstRequest.class.getName() + ".rolePrincipalClassName";
     
     private static volatile String [] CONTAINER_ATTR_NAME_PREFIXES = null;
-    
+    private static final String[] EMPTY_STRING_ARRAY = new String[0];
+
     protected String lifecyclePhase;
     protected HstRequestContext requestContext;
     protected Map<String, Map<String, String []>> namespaceParametersMap = new HashMap<String, Map<String, String []>>();
@@ -368,7 +369,7 @@
                         containerAttrNamePrefixes.addAll(this.requestContext.getContainerConfiguration().getList(CONTAINER_ATTR_NAME_PREFIXES_PROP_KEY));
                     }
                     
-                    CONTAINER_ATTR_NAME_PREFIXES = (String []) containerAttrNamePrefixes.toArray(new String[0]);
+                    CONTAINER_ATTR_NAME_PREFIXES = (String []) containerAttrNamePrefixes.toArray(EMPTY_STRING_ARRAY);
                 }
             }
         }
Index: components/session-pool/src/main/java/org/hippoecm/hst/core/jcr/pool/JcrHippoRepository.java
===================================================================
--- components/session-pool/src/main/java/org/hippoecm/hst/core/jcr/pool/JcrHippoRepository.java	(revision 32948)
+++ components/session-pool/src/main/java/org/hippoecm/hst/core/jcr/pool/JcrHippoRepository.java	(working copy)
@@ -39,7 +39,8 @@
 public class JcrHippoRepository implements Repository {
     
     private static final Logger log = LoggerFactory.getLogger(JcrHippoRepository.class);
-    
+    private static final String[] EMPTY_STRING_ARRAY = new String[0];
+
     protected String repositoryURI;
     
     protected HippoRepository hippoRepository;       // repository created via HippoRepositoryFactory
@@ -160,7 +161,7 @@
             }
         }
         
-        return new String[0];
+        return EMPTY_STRING_ARRAY;
     }
 
     public Session login() throws LoginException, RepositoryException {
Index: content-beans/src/main/java/org/hippoecm/hst/provider/jcr/JCRValueProviderImpl.java
===================================================================
--- content-beans/src/main/java/org/hippoecm/hst/provider/jcr/JCRValueProviderImpl.java	(revision 32948)
+++ content-beans/src/main/java/org/hippoecm/hst/provider/jcr/JCRValueProviderImpl.java	(working copy)
@@ -37,7 +37,12 @@
     private static final long serialVersionUID = 1L;
     
     private static final Logger log = LoggerFactory.getLogger(JCRValueProviderImpl.class);
-    
+    private static final String[] EMPTY_STRING_ARRAY = new String[0];
+    private static final Double[] EMPTY_DOUBLE_ARRAY = new Double[0];
+    private static final Long[] EMPTY_LONG_ARRAY = new Long[0];
+    private static final Calendar[] EMPTY_CALENDAR_ARRAY = new Calendar[0];
+    private static final Boolean[] EMPTY_BOOLEAN_ARRAY = new Boolean[0];
+
     // transient node because ValueProvider implements Serializable
     private transient Node jcrNode;
 
@@ -235,14 +240,14 @@
             return o;
         }
         if(this.propertyMap.isUnAvailableProperty(propertyName)) {
-            return new String[0];
+            return EMPTY_STRING_ARRAY;
         }
         
         loadProperty(propertyName,PropertyType.STRING, true);
         
         String[] val =  this.propertyMap.getStringArrays().get(propertyName);
         if(val == null) {
-            return new String[0];
+            return EMPTY_STRING_ARRAY;
         }
         return val;
     }
@@ -271,13 +276,13 @@
             return o;
         }
         if(this.propertyMap.isUnAvailableProperty(propertyName)) {
-            return new Double[0];
+            return EMPTY_DOUBLE_ARRAY;
         }
         
         loadProperty(propertyName,PropertyType.DOUBLE, true);
         Double[] val = this.propertyMap.getDoubleArrays().get(propertyName);
         if(val == null) {
-            return new Double[0];
+            return EMPTY_DOUBLE_ARRAY;
         }
         return val;
     }
@@ -307,13 +312,13 @@
             return o;
         }
         if(this.propertyMap.isUnAvailableProperty(propertyName)) {
-            return new Long[0];
+            return EMPTY_LONG_ARRAY;
         }
         
         loadProperty(propertyName,PropertyType.LONG, true);
         Long[] val = this.propertyMap.getLongArrays().get(propertyName);
         if(val == null) {
-            return new Long[0];
+            return EMPTY_LONG_ARRAY;
         }
         return val;
     }
@@ -340,13 +345,13 @@
             return (Calendar[])o.clone();
         }
         if(this.propertyMap.isUnAvailableProperty(propertyName)) {
-            return new Calendar[0];
+            return EMPTY_CALENDAR_ARRAY;
         }
         
         loadProperty(propertyName,PropertyType.DATE, true);
         Calendar[] val = this.propertyMap.getCalendarArrays().get(propertyName);
         if(val == null) {
-            return new Calendar[0];
+            return EMPTY_CALENDAR_ARRAY;
         }
         return val;
     }
@@ -375,12 +380,12 @@
             return o;
         }
         if(this.propertyMap.isUnAvailableProperty(propertyName)) {
-            return new Boolean[0];
+            return EMPTY_BOOLEAN_ARRAY;
         }
         loadProperty(propertyName,PropertyType.BOOLEAN, true);
         Boolean[] val  = this.propertyMap.getBooleanArrays().get(propertyName);
         if(val == null) {
-           return new Boolean[0];
+           return EMPTY_BOOLEAN_ARRAY;
         } 
         return val;
     }
Index: commons/src/main/java/org/hippoecm/hst/container/DefaultPortletRequestDispatcherImpl.java
===================================================================
--- commons/src/main/java/org/hippoecm/hst/container/DefaultPortletRequestDispatcherImpl.java	(revision 32948)
+++ commons/src/main/java/org/hippoecm/hst/container/DefaultPortletRequestDispatcherImpl.java	(working copy)
@@ -56,6 +56,7 @@
     private static final String PAIR_KEY_SEPARATOR = "hstPortletRequestDispatcherPathProvider.pair.key.separator";
     
     private static final Object[] EMPTY_OBJECT_ARRAY = new Object[0];
+    private static final String[] EMPTY_STRING_ARRAY = new String[0];
     private Map<String, PropertyDescriptor> propertyDescriptorCache;
 
     private String [] servletPathAttributeNames;
@@ -290,7 +291,7 @@
     
     private static String [] splitAndTrimToArray(String value, String regex) {
         if (value == null) {
-            return new String[0];
+            return EMPTY_STRING_ARRAY;
         }
         
         String [] values = value.split(regex);
Index: client/src/main/java/org/hippoecm/hst/component/support/bean/BaseHstComponent.java
===================================================================
--- client/src/main/java/org/hippoecm/hst/component/support/bean/BaseHstComponent.java	(revision 32948)
+++ client/src/main/java/org/hippoecm/hst/component/support/bean/BaseHstComponent.java	(working copy)
@@ -93,7 +93,8 @@
         "Please check HST-2 Content Beans Annotation configuration as servlet context parameter.\n" +
         "You can set a servlet context parameter named '" + BEANS_ANNOTATED_CLASSES_CONF_PARAM + "' with xml or classes location filter.\n" +
         "For example, '" + DEFAULT_BEANS_ANNOTATED_CLASSES_CONF + "' or 'classpath*:org/examples/beans/**/*.class'";
-    
+    private static final String[] EMPTY_STRING_ARRAY = new String[0];
+
     protected boolean beansInitialized;
     protected ObjectConverter objectConverter;
     protected HstQueryManagerFactory hstQueryManagerFactory;
@@ -202,7 +203,7 @@
         if (paramValues != null && paramValues.length > 0) {
             return paramValues;
         }
-        return new String[0];
+        return EMPTY_STRING_ARRAY;
     }
     
 
Index: client/src/main/java/org/hippoecm/hst/component/support/ClientComponentManager.java
===================================================================
--- client/src/main/java/org/hippoecm/hst/component/support/ClientComponentManager.java	(revision 32948)
+++ client/src/main/java/org/hippoecm/hst/component/support/ClientComponentManager.java	(working copy)
@@ -41,7 +41,8 @@
 import org.springframework.web.context.support.WebApplicationContextUtils;
 
 public class ClientComponentManager implements ComponentManager, ServletContextAware, BeanPostProcessor {
-    
+
+    private static final String[] EMPTY_STRING_ARRAY = new String[0];
     Logger logger = LoggerFactory.getLogger(ClientComponentManager.class);
     
     public static final String IGNORE_UNRESOLVABLE_PLACE_HOLDERS = ClientComponentManager.class.getName() + ".ignoreUnresolvablePlaceholders";
@@ -98,7 +99,7 @@
                 logger.warn("There's no valid component configuration.");
             }
         } else {
-            this.applicationContext.setConfigLocations(checkedConfigurationResources.toArray(new String [0]));
+            this.applicationContext.setConfigLocations(checkedConfigurationResources.toArray(EMPTY_STRING_ARRAY));
             
             if (configuration != null) {
                 Properties initProps = ConfigurationConverter.getProperties(configuration);
Index: client/src/main/java/org/hippoecm/hst/servlet/utils/BinaryPage.java
===================================================================
--- client/src/main/java/org/hippoecm/hst/servlet/utils/BinaryPage.java	(revision 32948)
+++ client/src/main/java/org/hippoecm/hst/servlet/utils/BinaryPage.java	(working copy)
@@ -32,6 +32,7 @@
 public class BinaryPage implements Serializable {
 
     private static final long serialVersionUID = 1L;
+    private static final byte[] EMPTY_BYTES = {};
 
     private final String path;
     private int status = HttpServletResponse.SC_NOT_FOUND;
@@ -41,7 +42,7 @@
     private long nextValidityCheckTimeStamp = -1L;
     private long creationTime;
     private long length;
-    private byte[] data = {};
+    private byte[] data = EMPTY_BYTES;
 
     /** 
      * Create a new binary page. This will just create the page holder. The fields have to
Index: client/src/main/java/org/hippoecm/hst/tag/BaseHstURLTag.java
===================================================================
--- client/src/main/java/org/hippoecm/hst/tag/BaseHstURLTag.java	(revision 32948)
+++ client/src/main/java/org/hippoecm/hst/tag/BaseHstURLTag.java	(working copy)
@@ -35,6 +35,7 @@
 public abstract class BaseHstURLTag extends ParamContainerTag {
     
     private static final long serialVersionUID = 1L;
+    private static final String[] EMPTY_STRING_ARRAY = new String[0];
 
     protected String var = null;
     
@@ -176,7 +177,7 @@
             
             List<String> valueList = parametersMap.get(key);
         
-            String[] valueArray = valueList.toArray(new String[0]);
+            String[] valueArray = valueList.toArray(EMPTY_STRING_ARRAY);
             
             url.setParameter(key, valueArray);
         }