Index: api/src/main/java/org/hippoecm/hst/core/container/ValveContext.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- api/src/main/java/org/hippoecm/hst/core/container/ValveContext.java	(revision 35096)
+++ api/src/main/java/org/hippoecm/hst/core/container/ValveContext.java	(revision )
@@ -64,7 +64,9 @@
      * @return
      */
     HttpServletResponse getServletResponse();
-    
+
+    void setHttpServletResponse(HttpServletResponse servletResponse);
+    
     /**
      * Sets the root {@link HstComponentWindow} instancethat is used to process the current request.
      * 
Index: components/core/pom.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- components/core/pom.xml	(revision 35096)
+++ components/core/pom.xml	(revision )
@@ -87,13 +87,18 @@
       <artifactId>commons-logging</artifactId> 
       <scope>provided</scope> 
     </dependency>
-    
+
     <dependency>
       <groupId>net.sf.ehcache</groupId>
       <artifactId>ehcache-core</artifactId>
     </dependency>
-    
+
     <dependency>
+      <groupId>net.sf.ehcache</groupId>
+      <artifactId>ehcache-web</artifactId>
+    </dependency>
+    
+    <dependency>
       <groupId>org.aspectj</groupId>
       <artifactId>aspectjweaver</artifactId>
     </dependency>
Index: components/core/src/main/java/org/hippoecm/hst/core/container/HstSitePipeline.java
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- components/core/src/main/java/org/hippoecm/hst/core/container/HstSitePipeline.java	(revision 35096)
+++ components/core/src/main/java/org/hippoecm/hst/core/container/HstSitePipeline.java	(revision )
@@ -228,7 +228,7 @@
 
         private final HstContainerConfig requestContainerConfig;
         private final HttpServletRequest servletRequest;
-        private final HttpServletResponse servletResponse;
+        private HttpServletResponse servletResponse;
         private HstComponentWindow rootComponentWindow;
         private HstComponentWindow rootComponentRenderingWindow;
         private final HstRequestContext requestContext;
@@ -266,6 +266,11 @@
         public HttpServletResponse getServletResponse() {
             return this.servletResponse;
         }
+
+        public void setHttpServletResponse(HttpServletResponse servletResponse) {
+            this.servletResponse = servletResponse;
+        }
+
 
         public void setRootComponentWindow(HstComponentWindow rootComponentWindow) {
             this.rootComponentWindow = rootComponentWindow;
Index: components/core/src/main/resources/org/hippoecm/hst/site/container/SpringComponentManager-pipelines.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- components/core/src/main/resources/org/hippoecm/hst/site/container/SpringComponentManager-pipelines.xml	(revision 35096)
+++ components/core/src/main/resources/org/hippoecm/hst/site/container/SpringComponentManager-pipelines.xml	(revision )
@@ -117,10 +117,21 @@
   
   <bean id="siteMenusResolvingValve" parent="abstractValve" class="org.hippoecm.hst.core.container.SiteMenusResolvingValve">
   </bean>
-  
+
   <bean id="actionValve" parent="abstractValve" class="org.hippoecm.hst.core.container.ActionValve">
   </bean>
-  
+
+  <bean id="pageBlockingCache" parent="abstractBlockingEhCache">
+    <property name="cacheName" value="pageBlockingCache" />
+    <!-- time to idle in seconds. default 1 day -->
+    <property name="timeToLive" value="86400" />
+    <property name="blocking" value="true" />
+  </bean>
+  
+  <bean id="pageCachingValve" parent="abstractValve" class="org.hippoecm.hst.core.container.PageCachingValve">
+     <property name="blockingCache" ref="pageBlockingCache"/>
+  </bean>
+
   <bean id="aggregationValve" parent="abstractValve" class="org.hippoecm.hst.core.container.AggregationValve">
   </bean>
   
@@ -158,6 +169,7 @@
                 <ref bean="jcrSessionStatefulConcurrencyValve"/>
                 <ref bean="siteMenusResolvingValve" />
                 <ref bean="actionValve" />
+                <ref bean="pageCachingValve"/>
                 <ref bean="resourceServingValve" />
                 <ref bean="componentRenderingValve" />
                 <ref bean="aggregationValve" />