Index: content/src/main/resources/content/en/products.xml
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- content/src/main/resources/content/en/products.xml	(revision 35728)
+++ content/src/main/resources/content/en/products.xml	(revision )
@@ -58,30 +58,54 @@
       </sv:property>
       <sv:property sv:name="jcr:mixinTypes" sv:type="Name" sv:multiple="true">
         <sv:value>hippo:harddocument</sv:value>
+        <sv:value>hippotranslation:translated</sv:value>
       </sv:property>
       <sv:property sv:name="jcr:uuid" sv:type="String">
-        <sv:value>d1785eaf-a6cb-40f7-8d61-07010cff7d92</sv:value>
+        <sv:value>38615a87-2854-48e8-a827-a094cb405e01</sv:value>
       </sv:property>
       <sv:property sv:name="hippo:related___pathreference" sv:type="String"/>
       <sv:property sv:name="hippostd:foldertype" sv:type="String" sv:multiple="true">
-        <sv:value>new-product</sv:value>
         <sv:value>new-product-folder</sv:value>
+        <sv:value>new-product</sv:value>
       </sv:property>
+      <sv:property sv:name="hippotranslation:id" sv:type="String">
+        <sv:value>6ff7b270-903f-442f-89dd-711217b6614f</sv:value>
+      </sv:property>
+      <sv:property sv:name="hippotranslation:locale" sv:type="String">
+        <sv:value>en</sv:value>
+      </sv:property>
+      <sv:node sv:name="hippotranslation:translations">
+        <sv:property sv:name="jcr:primaryType" sv:type="Name">
+          <sv:value>hippotranslation:translations</sv:value>
+        </sv:property>
+      </sv:node>
       <sv:node sv:name="11">
         <sv:property sv:name="jcr:primaryType" sv:type="Name">
           <sv:value>hippostd:folder</sv:value>
         </sv:property>
         <sv:property sv:name="jcr:mixinTypes" sv:type="Name" sv:multiple="true">
           <sv:value>hippo:harddocument</sv:value>
+          <sv:value>hippotranslation:translated</sv:value>
         </sv:property>
         <sv:property sv:name="jcr:uuid" sv:type="String">
-          <sv:value>216deeb2-acb0-4cfa-86da-bedd81b03cba</sv:value>
+          <sv:value>0355ef96-eb22-4be1-9974-e5faa7d17d8e</sv:value>
         </sv:property>
         <sv:property sv:name="hippo:related___pathreference" sv:type="String"/>
         <sv:property sv:name="hippostd:foldertype" sv:type="String" sv:multiple="true">
-          <sv:value>new-product</sv:value>
           <sv:value>new-product-folder</sv:value>
+          <sv:value>new-product</sv:value>
         </sv:property>
+        <sv:property sv:name="hippotranslation:id" sv:type="String">
+          <sv:value>94ce943e-4c2f-472f-a087-c4431a6a56ad</sv:value>
+        </sv:property>
+        <sv:property sv:name="hippotranslation:locale" sv:type="String">
+          <sv:value>en</sv:value>
+        </sv:property>
+        <sv:node sv:name="hippotranslation:translations">
+          <sv:property sv:name="jcr:primaryType" sv:type="Name">
+            <sv:value>hippotranslation:translations</sv:value>
+          </sv:property>
+        </sv:node>
         <sv:node sv:name="peppered-taters">
           <sv:property sv:name="jcr:primaryType" sv:type="Name">
             <sv:value>hippo:handle</sv:value>
@@ -91,19 +115,8 @@
             <sv:value>hippo:translated</sv:value>
           </sv:property>
           <sv:property sv:name="jcr:uuid" sv:type="String">
-            <sv:value>c2d549c5-17b8-468a-be9a-119db4289f8d</sv:value>
+            <sv:value>e5343481-9458-4260-994a-5de9d517cd1d</sv:value>
           </sv:property>
-          <sv:node sv:name="hippo:translation">
-            <sv:property sv:name="jcr:primaryType" sv:type="Name">
-              <sv:value>hippo:translation</sv:value>
-            </sv:property>
-            <sv:property sv:name="hippo:language" sv:type="String">
-              <sv:value/>
-            </sv:property>
-            <sv:property sv:name="hippo:message" sv:type="String">
-              <sv:value>Peppered taters</sv:value>
-            </sv:property>
-          </sv:node>
           <sv:node sv:name="peppered-taters">
             <sv:property sv:name="jcr:primaryType" sv:type="Name">
               <sv:value>hippogogreen:product</sv:value>
@@ -113,7 +126,7 @@
               <sv:value>hippotranslation:translated</sv:value>
             </sv:property>
             <sv:property sv:name="jcr:uuid" sv:type="String">
-              <sv:value>fce0798f-f080-4e7d-b130-da32d43c26b7</sv:value>
+              <sv:value>bf5f5499-4845-40b6-b3d8-15a5372a2a7e</sv:value>
             </sv:property>
             <sv:property sv:name="hippo:availability" sv:type="String" sv:multiple="true">
               <sv:value>live</sv:value>
@@ -162,10 +175,10 @@
               <sv:value>admin</sv:value>
             </sv:property>
             <sv:property sv:name="hippostdpubwf:publicationDate" sv:type="Date">
-              <sv:value>2011-11-29T09:58:52.422+01:00</sv:value>
+              <sv:value>2012-08-14T13:34:30.087+02:00</sv:value>
             </sv:property>
             <sv:property sv:name="hippotranslation:id" sv:type="String">
-              <sv:value>e29b2ce9-90fc-439d-8648-5f39c24d70b5</sv:value>
+              <sv:value>0e8a1d97-fd3e-4eb7-b34f-f202240850bb</sv:value>
             </sv:property>
             <sv:property sv:name="hippotranslation:locale" sv:type="String">
               <sv:value>en</sv:value>
@@ -242,7 +255,18 @@
               <sv:property sv:name="hippo:values" sv:type="String" sv:multiple="true"/>
             </sv:node>
           </sv:node>
+          <sv:node sv:name="hippo:translation">
+            <sv:property sv:name="jcr:primaryType" sv:type="Name">
+              <sv:value>hippo:translation</sv:value>
+            </sv:property>
+            <sv:property sv:name="hippo:language" sv:type="String">
+              <sv:value/>
+            </sv:property>
+            <sv:property sv:name="hippo:message" sv:type="String">
+              <sv:value>Peppered taters</sv:value>
+            </sv:property>
-        </sv:node>
+          </sv:node>
+        </sv:node>
         <sv:node sv:name="tamaras-ratatouille">
           <sv:property sv:name="jcr:primaryType" sv:type="Name">
             <sv:value>hippo:handle</sv:value>
@@ -252,7 +276,7 @@
             <sv:value>hippo:translated</sv:value>
           </sv:property>
           <sv:property sv:name="jcr:uuid" sv:type="String">
-            <sv:value>76a9cb31-948e-4167-b13c-e4b4ebbde258</sv:value>
+            <sv:value>ee4bb43c-6ce8-4a25-8f68-13dcea59882e</sv:value>
           </sv:property>
           <sv:node sv:name="hippo:translation">
             <sv:property sv:name="jcr:primaryType" sv:type="Name">
@@ -274,7 +298,7 @@
               <sv:value>hippotranslation:translated</sv:value>
             </sv:property>
             <sv:property sv:name="jcr:uuid" sv:type="String">
-              <sv:value>12c17dfd-3288-4171-a8b3-6c3d5175d540</sv:value>
+              <sv:value>b912311b-c8fe-459a-b5c4-8c09860f85f4</sv:value>
             </sv:property>
             <sv:property sv:name="hippo:availability" sv:type="String" sv:multiple="true">
               <sv:value>live</sv:value>
@@ -326,7 +350,7 @@
               <sv:value>2011-11-29T10:00:03.005+01:00</sv:value>
             </sv:property>
             <sv:property sv:name="hippotranslation:id" sv:type="String">
-              <sv:value>9dbf31d0-e612-4315-949f-dee4cf709a53</sv:value>
+              <sv:value>7d639a59-42be-40a2-8b61-fb384779c942</sv:value>
             </sv:property>
             <sv:property sv:name="hippotranslation:locale" sv:type="String">
               <sv:value>en</sv:value>
@@ -463,7 +487,7 @@
             <sv:value>hippo:translated</sv:value>
           </sv:property>
           <sv:property sv:name="jcr:uuid" sv:type="String">
-            <sv:value>f716df5e-f312-42f9-962b-6520d6dceee1</sv:value>
+            <sv:value>7bd724bb-9f2e-4134-a241-5a9071655f47</sv:value>
           </sv:property>
           <sv:node sv:name="hippo:translation">
             <sv:property sv:name="jcr:primaryType" sv:type="Name">
@@ -485,7 +509,7 @@
               <sv:value>hippotranslation:translated</sv:value>
             </sv:property>
             <sv:property sv:name="jcr:uuid" sv:type="String">
-              <sv:value>73273409-9f40-4bcf-8383-3dd2e89ffd15</sv:value>
+              <sv:value>67709814-62bc-478a-a6d0-8489603c39f7</sv:value>
             </sv:property>
             <sv:property sv:name="hippo:availability" sv:type="String" sv:multiple="true">
               <sv:value>live</sv:value>
@@ -540,7 +564,7 @@
               <sv:value>2012-01-19T16:19:18.651+01:00</sv:value>
             </sv:property>
             <sv:property sv:name="hippotranslation:id" sv:type="String">
-              <sv:value>f0cf4580-1c86-45e5-baf3-2473147ae0c2</sv:value>
+              <sv:value>a70fc67b-0037-4c69-bd66-659da6577ba1</sv:value>
             </sv:property>
             <sv:property sv:name="hippotranslation:locale" sv:type="String">
               <sv:value>en</sv:value>
@@ -625,7 +649,7 @@
             <sv:value>hippo:translated</sv:value>
           </sv:property>
           <sv:property sv:name="jcr:uuid" sv:type="String">
-            <sv:value>63aa341e-1a87-4741-9aae-7f8e554898ec</sv:value>
+            <sv:value>f47f5176-f369-4ffe-8579-cfc7c3464802</sv:value>
           </sv:property>
           <sv:node sv:name="hippo:translation">
             <sv:property sv:name="jcr:primaryType" sv:type="Name">
@@ -647,7 +671,7 @@
               <sv:value>hippotranslation:translated</sv:value>
             </sv:property>
             <sv:property sv:name="jcr:uuid" sv:type="String">
-              <sv:value>73a432cd-19f0-4904-9623-8b5dc7e0ba79</sv:value>
+              <sv:value>b3fd789d-df36-46c2-8424-871785649b35</sv:value>
             </sv:property>
             <sv:property sv:name="hippo:availability" sv:type="String" sv:multiple="true">
               <sv:value>live</sv:value>
@@ -702,7 +726,7 @@
               <sv:value>2011-11-29T10:08:30.027+01:00</sv:value>
             </sv:property>
             <sv:property sv:name="hippotranslation:id" sv:type="String">
-              <sv:value>ed7f4534-d100-4ba5-936c-1afdd2807186</sv:value>
+              <sv:value>9ae68f82-10ab-46c7-aa2a-5b2f933932e0</sv:value>
             </sv:property>
             <sv:property sv:name="hippotranslation:locale" sv:type="String">
               <sv:value>en</sv:value>
@@ -785,7 +809,7 @@
             <sv:value>hippo:translated</sv:value>
           </sv:property>
           <sv:property sv:name="jcr:uuid" sv:type="String">
-            <sv:value>e1d663b9-c784-46e9-81cf-d0be3185726b</sv:value>
+            <sv:value>9343ed8b-ce1d-40d2-aff8-656099733b62</sv:value>
           </sv:property>
           <sv:node sv:name="hippo:translation">
             <sv:property sv:name="jcr:primaryType" sv:type="Name">
@@ -807,7 +831,7 @@
               <sv:value>hippotranslation:translated</sv:value>
             </sv:property>
             <sv:property sv:name="jcr:uuid" sv:type="String">
-              <sv:value>97f6f071-c65c-45e3-9b00-a118b584bbcd</sv:value>
+              <sv:value>3e8df007-35c9-44ef-94af-5cf518188c72</sv:value>
             </sv:property>
             <sv:property sv:name="hippo:availability" sv:type="String" sv:multiple="true">
               <sv:value>live</sv:value>
@@ -862,7 +886,7 @@
               <sv:value>2011-11-29T10:32:27.313+01:00</sv:value>
             </sv:property>
             <sv:property sv:name="hippotranslation:id" sv:type="String">
-              <sv:value>194bd9f8-6afd-4c42-8957-0fa13bb1a3a4</sv:value>
+              <sv:value>f564b569-6b6b-4239-aec1-7a9f177f0a8c</sv:value>
             </sv:property>
             <sv:property sv:name="hippotranslation:locale" sv:type="String">
               <sv:value>en</sv:value>
@@ -978,7 +1002,7 @@
             <sv:value>hippo:translated</sv:value>
           </sv:property>
           <sv:property sv:name="jcr:uuid" sv:type="String">
-            <sv:value>5566ab38-7f9e-4e0d-9e5a-4197b079a714</sv:value>
+            <sv:value>313369a7-951e-4941-bd31-0d8c2154aeae</sv:value>
           </sv:property>
           <sv:node sv:name="hippo:translation">
             <sv:property sv:name="jcr:primaryType" sv:type="Name">
@@ -1000,7 +1024,7 @@
               <sv:value>hippotranslation:translated</sv:value>
             </sv:property>
             <sv:property sv:name="jcr:uuid" sv:type="String">
-              <sv:value>fc96591c-10b6-4afc-8083-ce6e916e7794</sv:value>
+              <sv:value>dea1fd25-b9b9-4cc5-8f21-cbff16be1c98</sv:value>
             </sv:property>
             <sv:property sv:name="hippo:availability" sv:type="String" sv:multiple="true">
               <sv:value>live</sv:value>
@@ -1055,7 +1079,7 @@
               <sv:value>2011-11-29T10:41:15.978+01:00</sv:value>
             </sv:property>
             <sv:property sv:name="hippotranslation:id" sv:type="String">
-              <sv:value>e258fb59-6306-409b-863e-d9cd0751b522</sv:value>
+              <sv:value>8051b38f-44c9-4181-ad4a-7be47762f348</sv:value>
             </sv:property>
             <sv:property sv:name="hippotranslation:locale" sv:type="String">
               <sv:value>en</sv:value>
@@ -3130,7 +3154,7 @@
             <sv:property sv:name="hippo:related___pathreference" sv:type="String">
               <sv:value>products/re-use/2010/07/Imprinted-Herb-garden-in-recyclable-tin-potter</sv:value>
             </sv:property>
-            <sv:property sv:name="hippogogreen:categories" sv:type="String">
+            <sv:property sv:name="hippogogreen:categories" sv:type="String" sv:multiple="true">
               <sv:value>Animals</sv:value>
               <sv:value>Garden</sv:value>
             </sv:property>
@@ -7546,7 +7570,7 @@
             <sv:property sv:name="hippo:related___pathreference" sv:type="String">
               <sv:value>products/animal--garden/2010/07/the-green-johanna-compost-bin</sv:value>
             </sv:property>
-            <sv:property sv:name="hippogogreen:categories" sv:type="String">
+            <sv:property sv:name="hippogogreen:categories" sv:type="String" sv:multiple="true">
               <sv:value>Animals</sv:value>
               <sv:value>Garden</sv:value>
             </sv:property>
@@ -7715,7 +7739,7 @@
             <sv:property sv:name="hippo:related___pathreference" sv:type="String">
               <sv:value>products/animal--garden/2010/07/humane-mouse-trap</sv:value>
             </sv:property>
-            <sv:property sv:name="hippogogreen:categories" sv:type="String">
+            <sv:property sv:name="hippogogreen:categories" sv:type="String" sv:multiple="true">
               <sv:value>Animals</sv:value>
               <sv:value>Garden</sv:value>
             </sv:property>
@@ -7910,7 +7934,7 @@
             <sv:property sv:name="hippo:related___pathreference" sv:type="String">
               <sv:value>products/animal--garden/2010/08/solar-centurian---outdoor-security-light</sv:value>
             </sv:property>
-            <sv:property sv:name="hippogogreen:categories" sv:type="String">
+            <sv:property sv:name="hippogogreen:categories" sv:type="String" sv:multiple="true">
               <sv:value>Garden</sv:value>
               <sv:value>Animals</sv:value>
             </sv:property>
@@ -8059,7 +8083,7 @@
             <sv:property sv:name="hippo:related___pathreference" sv:type="String">
               <sv:value>products/animal--garden/2010/08/earth-kit</sv:value>
             </sv:property>
-            <sv:property sv:name="hippogogreen:categories" sv:type="String">
+            <sv:property sv:name="hippogogreen:categories" sv:type="String" sv:multiple="true">
               <sv:value>Animals</sv:value>
               <sv:value>Garden</sv:value>
             </sv:property>
@@ -8363,7 +8387,7 @@
             <sv:property sv:name="hippo:related___pathreference" sv:type="String">
               <sv:value>products/animal--garden/2010/08/insta-lite-clear-dynamo-flashlight</sv:value>
             </sv:property>
-            <sv:property sv:name="hippogogreen:categories" sv:type="String">
+            <sv:property sv:name="hippogogreen:categories" sv:type="String" sv:multiple="true">
               <sv:value>Garden</sv:value>
               <sv:value>Animals</sv:value>
             </sv:property>
@@ -8503,7 +8527,7 @@
             <sv:property sv:name="hippo:related___pathreference" sv:type="String">
               <sv:value>products/animal--garden/2010/08/gardn-gro-filter</sv:value>
             </sv:property>
-            <sv:property sv:name="hippogogreen:categories" sv:type="String">
+            <sv:property sv:name="hippogogreen:categories" sv:type="String" sv:multiple="true">
               <sv:value>Animals</sv:value>
               <sv:value>Garden</sv:value>
             </sv:property>
@@ -8617,6 +8641,9 @@
   <sv:node sv:name="facetedproducts">
     <sv:property sv:name="jcr:primaryType" sv:type="Name">
       <sv:value>hippofacnav:facetnavigation</sv:value>
+    </sv:property>
+    <sv:property sv:name="hippo:count" sv:type="Long">
+      <sv:value>75</sv:value>
     </sv:property>
     <sv:property sv:name="hippo:docbase" sv:type="String">
       <sv:value>c3b1c420-84cb-4e65-bbeb-b43a29a5a9d7</sv:value>